/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Fre Nov 10 16:22:38 CET 2000
    copyright            : (C) 2000 by Markus Fruehwirth
    email                : 7ox@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SJBplus.h"


/* name: matrix
 * var: none
 * exitcode:0 (for normal termination - returncode)
 * explanation: generates from mappingfile a vector
*/
int
doit (char *filename)
{
  int back;
  FILE *read, *write;		//filename
  char *line;	//line
  double minimum;       //minimum in the file
  char current;     //current character
  int stop;
  double *valuep, value;
  int i;

  valuep = &value;
back=-1;
minimum=0;
value=0;
i=0;
//find minimum in file now
  read = fopen (filename, "r");

  if (read == NULL)		//no file opened
    exit (ERROR);

stop=FALSE;
while (stop==FALSE)
{
  current=fgetc(read); //read a character
if (current > ASCII_AT)
   {
while (current != ASCIINEWLINE)
current=fgetc(read);
   }

if ((current == ASCIIMINUS) || ((current >= ASCIIZERO) && (current <= ASCIININE)))
{  //current character is a number
  line = malloc (MAXLENLINE * sizeof (char));
i=0;
line[i]=current;
current=fgetc(read); //read a character
    while ((current == ASCIIDOT) || ((current >= ASCIIZERO) && (current <= ASCIININE)))
    {
    i++;
    line[i]=current;
    current=fgetc(read); //read a character
    }
i++;
line[i]='\0';
back = sscanf (line, "%lf", valuep);
if (value < minimum)
    minimum=value;
free(line);
}

if (current==EOF)
    stop=TRUE;
}//stop

(void) fclose(read);
//minimum now saved in minimum
minimum=(minimum*(-1))+1;
//ready to add!


//now processing
  read = fopen (filename, "r");
  write = stdout;

  if (read == NULL)		//no file opened
    exit (ERROR);

stop=FALSE;
while (stop==FALSE)
{
  current=fgetc(read); //read a character

if (current==ASCIIDOLLAR)  //parameters untouched
{
while (current != ASCIINEWLINE)
{
fprintf(write, "%c", current);
current=fgetc(read);
}
fprintf(write, "%c", current);
}

if ((current == ASCIIMINUS) || ((current >= ASCIIZERO) && (current <= ASCIININE)))
{  //current character is a number
  line = malloc (MAXLENLINE * sizeof (char));
i=0;
line[i]=current;
current=fgetc(read); //read a character
    while ((current == ASCIIDOT) || ((current >= ASCIIZERO) && (current <= ASCIININE)))
    {
    i++;
    line[i]=current;
    current=fgetc(read); //read a character
    }
i++;
line[i]='\0';
back = sscanf (line, "%lf", valuep);
//value now keeps the read double
value=value+minimum;
//value is now positive
free(line);

fprintf(write, "%f ", value);
}

if (current==EOF)
    stop=TRUE;

if (current > ASCII_AT)
{
    while (current != ASCIINEWLINE)
    {
    fprintf(write, "%c", current);
    current=fgetc(read);
    if (current==EOF)
        {
        stop=TRUE;
        current=ASCIINEWLINE;
        }
    }
    fprintf(write, "%c", current);
}


}//stop

(void) fclose(read);
(void) fflush(write);


  if (back > 0)
    back = 0;

  return back;
}


/* name: main
 * var: none
 * exitcode:0 (for normal termination - returncode)
 * explanation: calls doit
*/
int
main (int argc, char *argv[])
{
  int back = -1;

  if (argc == 2)
    back = doit (argv[1]);
  else
    {
      (void) fprintf (stderr, "%s: wrong Usage: %s filename\n", argv[0], argv[0]);
      exit (EXIT_FAILURE);
    }
  return back;
}
